<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>CHAT</title>
</head>
<body>
    <div>
        <label>Choose a room:</label>
        <select id="roomSelect">
            <option value="public">Public</option>
            <option value="private">Private</option>
        </select>
        <input type="password" id="password" placeholder="Password (for private room)" />
        <button onclick="joinRoom()">Join</button>
    </div>
    <div id="chatArea">
        <div id="messages"></div>
        <input type="text" id="messageInput" placeholder="Type a message..." />
    </div>
    <script src="/socket.io/socket.io.js"></script>
    <script>
        const socket = io();

        let username = prompt('What username do you want?');
        socket.emit('setUsername', username);

        function joinRoom() {
            let room = document.getElementById('roomSelect').value;
            let password = document.getElementById('password').value;

            socket.emit('joinRoom', { room, password });
        }

        socket.on('usernameSet', (user) => {
            document.getElementById('chatArea').style.display = 'block';
        });

        socket.on('joinError', (error) => {
            alert(error);
        });

        socket.on('message', (message) => {
            let messagesDiv = document.getElementById('messages');
            messagesDiv.innerHTML += `<p>${message}</p>`;
        });

        document.getElementById('messageInput').addEventListener('keydown', (e) => {
            if (e.key === 'Enter' && e.target.value.trim() !== '') {
                socket.emit('sendMessage', e.target.value);
                e.target.value = '';
            }
        });
    </script>
</body>

<style>
body {
    font-family: 'Arial', sans-serif;
    background-color: #f7f9fc;
    margin: 0;
    padding: 0;
    display: flex;
    justify-content: center;
    align-items: center;
    height: 100vh;
    color: #333;
}

#chatArea {
    display: none;
    max-width: 600px;
    height: 600px;
    border-radius: 15px;
    box-shadow: 0 5px 15px rgba(0, 0, 0, 0.1);
    overflow: hidden;
    flex-direction: column;
    background-color: #fff;
}

#messages {
    flex-grow: 1;
    padding: 20px;
    max-height: 500px;
    overflow-y: auto;
    border-bottom: 1px solid #e0e0e0;
    display: flex;
    flex-direction: column;
    gap: 10px;
}

#messages p {
    width: 100%;
    padding: 8px 12px;
    border-radius: 15px;
    display: block;
    margin: 5px 0;
}

#messages .system {
    background-color: #d1d8e0;
    text-align: center;
    font-style: italic;
}

#messages .user {
    background-color: #007BFF;
    color: white;
    align-self: flex-end;
    border-top-right-radius: 5px;
}

#messages .member {
    background-color: #e5e8ed;
    align-self: flex-start;
    border-top-left-radius: 5px;
}

#messageInput {
    width: 100%;
    padding: 10px;
    border: none;
    outline: none;
    border-top: 1px solid #e0e0e0;
}

#roomSelect, #password {
    margin: 10px;
    padding: 10px;
    border-radius: 4px;
    border: 1px solid #ddd;
    outline: none;
    transition: border 0.3s ease;
}

#roomSelect:focus, #password:focus {
    border-color: #007BFF;
}

button {
    padding: 10px 15px;
    background-color: #007BFF;
    border: none;
    border-radius: 4px;
    color: white;
    cursor: pointer;
    transition: background-color 0.3s ease, transform 0.3s ease;
}

button:hover {
    background-color: #0056b3;
    transform: scale(1.05);
}

/* Additional styling for a gradient background and slight inner shadow for input */
#messageInput {
    background: linear-gradient(90deg, #f7f9fc, #e6e9ed);
    box-shadow: inset 0 0 5px rgba(0,0,0,0.2);
}


/* General styles */
.message {
    padding: 10px;
    margin: 5px;
    border-radius: 10px;
    max-width: 70%; /* Makes sure the messages don't take up the full width */
    clear: both;
    overflow: hidden;
}

.system {
    background-color: #eee;
    color: #888;
    text-align: center;
}

.user {
    background-color: #0099FF;
    color: white;
    float: right;
}

.other {
    background-color: #e1e1e1;
    float: left;
}



</style>
<script>
socket.on('message', (message) => {
    let messagesDiv = document.getElementById('messages');
    
    // Determine the type of the message
    let messageClass;
    if (message.includes('joined')) {
        messageClass = 'system';
    } else if (message.startsWith(username)) {
        messageClass = 'user';
    } else {
        messageClass = 'other';
    }

    messagesDiv.innerHTML += `<div class="${messageClass}">${message}</div>`;
    
    // Auto-scroll to the latest message
    messagesDiv.scrollTop = messagesDiv.scrollHeight;
});


</script>
</html>
